{looks at fpc map file & extracts useful info}
{NB distributed on same basis as fpc /source} 
program look_map;

{ t is used for testing..}
{$define xt}

{undefine if there is no dos module (used for file time +size only) }
{$define dosok}

{$ifdef dosok}
uses dos;
{$endif}

const ver='look_map 1.2';

{ change these if you need to}
{ size of string array with useful lines of map file read in}
const max_lines=5000;

{ max no of modules in link map}
      max_mods=150;

{max string length stored}
      max_len=200;

var map:array [0..max_lines] of string[max_len];
    mod_names:array[1..max_mods] of string[max_len];

    fin, fout:text;
    infile, outfile, s, options:string;
    no_lines,i,j,k,l, load_line,p,size, tsize, bsize,osize, 
       dsize, isize, fsize, csize :longint;
    
    debug, readfl,long:boolean;

{$ifdef dosok}
    dt:datetime;
{$endif}

    stime,marker,sw:string;
    time,n:longint;
    mapfsize:longint;
    test:boolean;
    s1,line1:string;
    
{$ifdef dosok}
{filesize of file name}
function filesize(s:string): longint;
var dir:searchrec;
begin
  FindFirst(s,$20,Dir);
  while (DosError=0) do
   begin
{
     Writeln(Dir.Name+Space(40-Length(Dir.Name)),Dir.Size:9);
}
     FindNext(Dir);
   end;     
  FindClose(Dir); 
filesize:=dir.size;
end;
{$endif}

procedure notify;
begin
write(' please notify leej@logica.com ');
end;

procedure error(s:string);
begin
writeln(ver,' error:', s);
halt(1);
end;


Function L0(w:word):string;
var  s : string;
              begin
                Str(w,s);
                if w<10 then
                 L0:='0'+s
                else
                 L0:=s;
              end;


{ converts hex string (lower case) to longint}
{ terminator space or length of string}
{ nb non hex digits ignored}
function str_no(s:string):longint;
var j, tot,n:longint;
begin

tot:=0;
j:=1;

repeat
tot:=tot*16;

n:=0;
if ( (s[j]>='0') and (s[j]<='9') ) then n:=ord(s[j])-ord('0');
if ( (s[j]>='a') and (s[j]<='f') ) then n:=ord(s[j])-ord('a')+10;
tot:=tot+n;
j:=j+1;

until ( (s[j]=' ') or (j>length(s)) );

str_no:=tot;

end;


begin

test:=false;
{$ifdef t} test:=true; {$endif} 

debug:=false;
infile:=lowercase(paramstr(1));
sw:='';

n:=pos('/',infile); 
if n>0 then
begin
sw:=copy(infile,n+1,10);
infile:=copy(infile,1,n-1);
{
writeln('infile, sw=',infile,' ',sw);
}
end;

if infile='' then infile:='mapop.map';
long:=pos('l',sw)>0;

if ( (infile='?') or (infile='h')) then
begin
writeln('look_map [infile][sw] [outfile] [options]');
writeln(' infile is i/p filename (defaults to mapop.map), outfile is o/p filename');
writeln('  analyses map o/p from & outputs to console + outfile');
writeln('   a list of the modules used & their sizes + total');
writeln('  useful with smartlinking to see what is happening');
writeln('  to get map o/p use "-k-Map filename" as parameter in fpc');
writeln;
writeln('if /sw=nul the total size of each module is o/p to console');
writeln('  else if /l the sizes of each data category is o/p');
writeln;
writeln('the sizes of each data category ie total, .text, .bss, .data, .idata');
writeln(' , common are always o/p to outfile. The sizes of each ');
writeln('   component are also o/p to outfile if option=d');
writeln;
writeln('sets errorlevel ne 0 if error');
writeln; 
writeln('see look_map.txt for release notes');
writeln('works with fpc win32, go32v2, linux releases/snapshots 99.14 onwards');
writeln(ver, ' John Lee, leej@logica.com');
halt;
end;


outfile:=lowercase(paramstr(2));
if outfile='' then outfile:='map.tmp';

options:=lowercase(paramstr(3));

{
writeln('look_map:  infile, outfile, options=', infile, ' ',outfile, ' ',options); 
}

mapfsize:=200000;
{$ifdef dosok}
mapfsize:=filesize(infile);
{$endif}


{$i-}
assign(fin,infile);
reset(fin);
if ioresult<>0 then begin writeln('error-- cannot open i/p file-',infile); halt(1);  end;
{$i+}

{map files are usually v big >50K bytes}
if mapfsize<10000 then 
begin
writeln('warning --invalid map file ie too small for map file?', infile, ' ', mapfsize);
end;

stime:='';

{$ifdef dosok}
GetFTime(fin,Time);
UnPackTime(Time,DT);

stime:=L0(DT.day)+'/'+L0(word(DT.month))+'/'+copy(l0(DT.Year),3,2);
stime:=stime + ' '+L0(DT.Hour)+':'+L0(DT.Min);
{$endif}


{$i-}
assign(fout, outfile); 
rewrite(fout);
if ioresult<>0 then begin writeln('error-- cannot write file-',outfile); halt(1);  end;
{$i+}

{ start storing after marker found to minimise wasted memory- previous stuff not used}
readfl:=false;
no_lines:=0;
n:=0;
{ marks start of useful date}
marker:='configuration';

while not eof(fin) do 
begin
n:=n+1;
readln(fin, s1);
s:=lowercase(s1);

{put 1st line (compile info?) into o/p}
if pos(marker,s)>0 then 
begin 
{
writeln(' start storing at line ',n);
}
readfl:=true; 
end; 

{get last line}
line1:=s1;

if length(s)>max_len then
 begin writeln('error-- line too long, max_len=',max_len,' line no:',n); halt(1); end;

if readfl then
begin
map[no_lines]:=s;
no_lines:=no_lines+1;
end;
if no_lines>max_lines then 
 begin writeln('error-- too many lines (max_lines)=',max_lines); halt(1); end;
end;
close(fin);

if not readfl then
begin
writeln(' error-- :', marker, ': not found in map file');
notify;
halt(1);  
end;

if debug then writeln('no lines-',no_lines);

{write line1 if it's got using in it, because it is compiler etc info}
if pos(' using ',line1)>0 then 
begin
writeln(fout, line1);
writeln(fout);
end;

writeln(fout, ' i/p map file ', infile, ' ',stime);


load_line:=-1;
k:=1;

for j:=0 to no_lines do 
begin

s:='load ';
if pos(s, map[j]) >0  then 
begin 
{ writeln(map[j]); }

{ store last line with load on it} 
load_line:=j;

 mod_names[k]:=copy(map[j],length(s)+1,100);

if debug then  writeln(k, ' ',mod_names[k]);

writeln(fout, k, ' ',mod_names[k]);
 
 k:=k+1;
 if k>max_mods then begin  writeln(' error-- too many module names (max_mods)=',max_mods); halt(1);end;
end;
end;
k:=k-1;

if load_line=-1 then 
begin writeln(' error-- no load text found in map file'); notify; halt(1); end;

writeln(fout);

{start line for rest of program, 1 after the last load}
load_line:=load_line+1;

write(ver, ', i/p file:', infile, ' ',stime);
if options<>'' then write(', options:',options);
writeln(', ',k,' modules');

if debug then writeln('no of mod names, end_line=', k, ' ',load_line);

osize:=0;
fsize:=0;

{-----------------------------main loop---------------------}
{for all the mod_names}
for l:=1 to k do
begin
write(mod_names[l],':'); 
writeln(fout,'-',mod_names[l]); 

size:=0;
tsize:=0;
dsize:=0;
bsize:=0;
isize:=0;
csize:=0;

{search whole map after line with end }
for j:=load_line to no_lines do
begin

{fill is not asociated with any module}
if pos('*fill',map[j])>0 then 
begin

s:=map[j];
p:=pos('0x',s);
if p>0 then delete(s,1,p+1) else writeln (' --no 1st hex no ln:',map[j]);

p:=pos('0x',s);
if p>0 then delete(s,1,p+1) else writeln ('--no 2nd hex no ln:',map[j]);
fsize:=fsize+str_no(s);

end;


if pos(mod_names[l],map[j])>0  then
begin

{found module name so get 2nd hex string (the size)}
s:=map[j];

p:=pos('0x',s);
if p>0 then delete(s,1,p+1) else 
begin
write ('NB no 1st hex no ln:',map[j]);
write (fout,'NB no 1st hex no ln:',map[j]);
end;

p:=pos('0x',s);
if p>0 then delete(s,1,p+1) else 
begin
writeln('error-- NB no 2nd lex no ln:',map[j]);
end;


if ( (pos('common',map[j])<=0) and (pos('.bss', map[j])<=0) ) then 
begin
size:=size+str_no(s);
end;

if pos('.text',map[j])>0 then tsize:=tsize+str_no(s);
if pos('.bss',map[j])>0 then bsize:=bsize+str_no(s);
if pos('.data',map[j])>0 then dsize:=dsize+str_no(s);
if pos('.idata',map[j])>0 then isize:=isize+str_no(s);
{
if pos('common',map[j])>0 then csize:=csize+str_no(s);
}

{ o/p all the components within size ie the next n lines until next no blank field} 
{ + their individual sizes}
if options='d' then
begin

k:=1;
{while next 1st fields =spaces ie blank}
while copy(map[j+k],1,5) = copy('       ',1,5) do
begin
s:=map[j+k];
p:=pos('0x',s);
if p>0 then delete(s,1,p+1) else writeln (fout,' ----warning no hex number ln:',s);

writeln(fout, copy(map[j],1,10)+copy(map[j+k], 40,30), ' ',str_no(s));
k:=k+1;
end; 

end; {if option=d}

{
writeln(fout,map[j]);
}
end;{if mod name found} 

end; {j loop}

write(' ',size);
if test then write(' ', filesize(mod_names[l]));

if not long then writeln;

if long then
begin
write(' ',tsize, ' ', bsize, ' ', dsize, ' ',isize, ' ',csize);
writeln(' (',tsize+bsize+dsize+isize+csize,')'); 
end;

write(fout, 'sizes: total, text, bss, data, idata, common=',size);
write(fout, ' ',tsize, ' ', bsize, ' ', dsize, ' ',isize, ' ',csize);
writeln(fout,' (',tsize+bsize+dsize+isize+csize,')'); 
writeln(fout);

osize:=osize+size;

end; {l loop}
{------------------------end main loop------------------------}

writeln;
writeln('linked size, *fill size=',osize,' ',fsize);
writeln(fout, 'linked size, *fill size=',osize,' ',fsize);
writeln(fout);
writeln(fout, '(no lines,modules,load_line=',l, ' ',no_lines,' ', load_line,')'); 
close(fout);


end.